#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#define N 20

int type;	//用来判断字符是半角还是全角

/*	2013-12-6 version 1.0  auther shencz2000
	email: shencz2000@sina.com
english.txt文件是英文，里面都是半角英文字母和字符。
chinese.txt文件中的文字都是汉字和全角标点符号。
mydrill.txt文件中的文字都是汉字和全角标点符号。
这些文件每一行都不能超过80个半角字符或者40个全角字符。
将其中一个文件的文本按行读到数组中来，最多只能读取 N 行。*/

int main (void)
{ 
  int select_file (char filename[]);
  int type_drilling (char array[][150]);
  FILE * fp;
  char array[N][150], fname[20];
  int i=0,j;
  system ("clear");		//清理屏幕
  select_file (fname);
  if ((fp=fopen(fname,"r"))==NULL)
    { 
    printf ("can't open file!\n");
    exit (0);
    }
  while (i<N && fgets(array[i],150,fp) != NULL) ++i;	
  array[i][0]='\0';		//对序号为i的那一行进行处理，避免出现乱码
  type_drilling (array);
  fclose (fp);
  return 0;
}
  
int type_drilling (char array[][150])	//打字练习函数
{ 
  int right_words (char * p, char * string);
  int i=0,j=0,k=0,m,n,s=0,t;
  time_t start,stop;
  float time_used, speed, rightw=0;
  char * p, string[150]={"start drilling"};
  while ( i < N && strlen (array[i]) != 0)
  { 
    p=array[i];
    j=0;
    while (j<3 && rightw<90 && strcmp(string, "quit")!=0)
    { 
      printf ("  %s  ",p);
      s++;
      time (& start);
      //下面的两条语句是将输入保存到1维字符数组里
      for (k=0; (string[k] = getchar()) != '\n'; k++) ;
      string[k]='\0';
      time (& stop);
      time_used=difftime (stop, start);
      m=strlen(p)-1;		//该字符串包括换行符，因此字符串长度要减 1
      if (type >0) 
        { k=k/3; m=m/3;}	//一个汉字的utf8编码是3个字节
      n=right_words(p,string);	//调用统计正确的字数的函数
      speed=60*k/(time_used+0.1);	// +0.1是为了避免出现分母太小的情况
      //printf ("the words:%d, right words:%d\n",m,n);
      if (m > 0) rightw=n*100/m;
      else rightw=100;
      printf ("  Speed:%5.0f, right ratio:%5.0f \n\n",speed,rightw);
      j++;
      s+=3;
    }
    if (s > 17)
    {
      s=0;
      system ("clear");		//执行清屏指令
      printf ("  speed:%5.0f, right ratio:%5.0f \n\n",speed,rightw);
    }
    rightw=0;
    if(i<N)  ++i;
  }
  return 0;
}


int select_file (char filename[])	//选择哪一个文件
{
  int i,k;
  char array[3][20]={"english.txt","chinese.txt","mydrill.txt"};
  printf ("  Please input 1 , 2 or 3 to select a file for drilling.\n");
  for (i=0; i<3; i++) 
  printf ("  %d file name is: %s\n",(i+1),array[i]);
  printf ("  ");
  scanf ("%d",&k);
  getchar();		//接收一个字符，在这里是换行符
  system ("clear");	//清理屏幕
  if (k<1 || k>3)
  {
    printf ("\n  The number is wrong, so the first file is used\n");
    k=1;
  }
  strncpy(filename,array[k-1],20);
  type=k-1;		// 0代表英文半角字符, >0代表中文全角字符.
  printf ("\n");
  return 0;
}


int right_words (char * p, char * string)	//统计打字正确的字数，对于英文来说则统计正确的字符数
{
  int i,k=0,r,s,t=0;
  r=strlen(p);
  s=strlen(string);
  if (s>r) s=r;
  if (type==0)		//如果是英文半角字符
  {
    for (i=0; i<s; i++)
      if (*p++ == *string++) k++;
  }
  else 			//如果是中文全角字符
  {
    for (i=0; i<s; i++)
    {
      if (*p++ == *string++) t++;
      if (t == 3) k++;
      if ((i+1)%3 == 0) t=0;
    }
  }	
  return k;
}
